"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const command_1 = require("@oclif/command");
const command_constants_1 = require("../constants/command.constants");
const messages_constants_1 = require("../constants/messages.constants");
const process_manager_1 = require("../libs/process-manager");
const utils_1 = require("../libs/utils");
class List extends command_1.Command {
    async run() {
        try {
            const processes = await process_manager_1.ProcessManager.list();
            if (processes.length) {
                utils_1.logProcesses(processes);
            }
            else {
                this.log(messages_constants_1.Messages.CLI.NO_RUNNING_PROCESS);
            }
        }
        catch (error) {
            this.error(error.message);
        }
        finally {
            process_manager_1.ProcessManager.disconnect();
        }
    }
}
exports.default = List;
List.description = 'List running mock APIs';
List.examples = ['$ mockoon-cli list'];
List.flags = Object.assign({}, command_constants_1.commonFlags);
//# sourceMappingURL=list.js.map