import { Command, flags } from '@oclif/command';
export default class Start extends Command {
    static description: string;
    static examples: string[];
    static flags: {
        pname: flags.IOptionFlag<string | undefined>;
        /**
         * /!\ Undocumented flag.
         * Mostly for internal use when `start `command is called during
         * a Docker image build.
         *
         * When using the `dockerize` command, file loading, validity checks,
         * migrations, etc. are all performed, and the single environment is
         * extracted in a separated file next to the generated Dockerfile.
         * It's easier to directly provide this file to the `start` command run
         * from the Dockerfile when building the Docker image rather than
         * having the image build failing due to a failure in the `start` command.
         */
        container: import("@oclif/parser/lib/flags").IBooleanFlag<boolean>;
        data: flags.IOptionFlag<string>;
        name: flags.IOptionFlag<string | undefined>;
        index: import("@oclif/parser/lib/flags").IOptionFlag<number | undefined>;
        port: import("@oclif/parser/lib/flags").IOptionFlag<number | undefined>;
        help: import("@oclif/parser/lib/flags").IBooleanFlag<void>;
    };
    run(): Promise<void>;
}
