import { Environments } from '@mockoon/commons';
import { ProcessDescription } from 'pm2';
/**
 * Load and parse a JSON data file
 *
 * @param filePath
 */
export declare const parseDataFile: (filePath: string) => Promise<Environments>;
/**
 * Load the data file, find and migrate the environment
 * copy the environment to a new temporary file.
 *
 * @param environments - path to the data file or export data
 * @param options
 */
export declare const prepareData: (environments: Environments, options: {
    name?: string;
    index?: number;
    port?: number;
    pname?: string;
}, dockerfileDir?: string | undefined) => Promise<{
    name: string;
    protocol: string;
    port: number;
    dataFile: string;
}>;
/**
 * Clean the temporary data files by deleting the ones with no
 * matching running process
 *
 * @param processes
 */
export declare const cleanDataFiles: (processes: ProcessDescription[]) => Promise<void>;
