import * as pm2 from 'pm2';
import { Proc, ProcessDescription } from 'pm2';
export declare type ConfigProcess = {
    name?: string;
    pid: number;
    port: number;
};
/**
 * Manage the file containing the running processes list
 */
export declare const ProcessListManager: {
    addProcess: (configProcess: ConfigProcess) => Promise<void>;
    getProcesses: () => ConfigProcess[];
    updateProcesses: (processes: pm2.ProcessDescription[]) => Promise<void>;
    deleteProcess: (name?: string | undefined) => void;
};
/**
 * Promisify PM2 methods
 */
export declare const ProcessManager: {
    info: (arg1: string | number) => Promise<pm2.ProcessDescription[]>;
    list: () => Promise<ProcessDescription[]>;
    start: (options: pm2.StartOptions) => Promise<Proc>;
    delete: (arg1: string | number) => Promise<pm2.Proc>;
    disconnect: typeof pm2.disconnect;
};
