import { Environments } from '@mockoon/commons';
import { ProcessDescription } from 'pm2';
/**
 * Display a list of running processes information
 *
 * @param processes
 */
export declare const logProcesses: (processes: ProcessDescription[]) => void;
/**
 * Transform an environment name to be used as a process name
 *
 * @param environmentName
 */
export declare const transformEnvironmentName: (environmentName: string) => string;
/**
 * Check if a port is already in use
 * @param port
 */
export declare const portInUse: (port: number) => Promise<boolean>;
/**
 * Check if a port is valid
 *
 * @param port
 */
export declare const portIsValid: (port: number) => boolean;
/**
 * Check if --index or --name flag are provided and
 * prompt user to choose an environment
 *
 * @param flags
 * @param environments
 */
export declare const promptEnvironmentChoice: <T extends {
    index: number | undefined;
    name: string | undefined;
}>(flags: T, environments: Environments) => Promise<T>;
